const kWindowMediatorContractID = "@mozilla.org/appshell/window-mediator;1";
const kWindowMediatorIID = Components.interfaces.nsIWindowMediator;
const kWindowMediator = Components.classes[kWindowMediatorContractID].getService(kWindowMediatorIID);
var biofoxPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");

function biofoxLoadOptions() {
        document.getElementById('biofoxEmail').value = biofoxPrefs.getCharPref('sEmail');
        document.getElementById('biofoxFirstname').value = biofoxPrefs.getCharPref('sFirstname');
        document.getElementById('biofoxLastname').value = biofoxPrefs.getCharPref('sLastname');
}

function biofoxSaveOptions(){
    var email;
    var firstname;
    var lastname;

        email = document.getElementById('biofoxEmail').value;
        firstname = document.getElementById('biofoxFirstname').value;
        lastname = document.getElementById('biofoxLastname').value;

        biofoxPrefs.setCharPref("sEmail", email);
        biofoxPrefs.setCharPref("sFirstname", firstname);
        biofoxPrefs.setCharPref("sLastname", lastname);

    return true;
}

function biofoxShowOptions(){
window.openDialog("chrome://biofox/content/biofox-pref.xul");
}

function uninstall(){
window.openDialog("chrome://biofox/content/uninstall.xul");
}

function getSelection() {
   var text = window._content.document.getSelection();

   // if nothing selected in the document then perhaps there is a
   // selection contained within a frame of the current document
   if (!text) {
       for (var i = 0; i < _content.frames.length; i++) {
           text = _content.frames[i].document.getSelection();
           if (text) break;
       }
   }
   return text;
}

function openWindow(url, processedSeq, flag) {
	var j=0;
   	var openWind=window.open(url, "", "resizable=yes,width=510,height=300");
   	openWind.document.write("<html><head><title></title></head><body><table width=400 bgcolor=eeeeee><tr><td><table><tr><td><font face=courier size=2>");
	if (flag==0){
		openWind.document.write("<b>>Sequence</b><br>");
	} else {
		openWind.document.write("<b>Error Code</b><br>");
	}
	for (var i=0; i<(processedSeq.length); i++){
		openWind.document.write(processedSeq.charAt(i));
		j++;
		if (j==60){
			openWind.document.write("\n");
			j=0;
		}
	}
	openWind.document.write("</font></td></tr></table></td></tr></table></body></html>");
   	openWind.document.close();  
}

function strip(selectedSeq){
	selectedSeq = selectedSeq.replace(/[\n\t\s ]/g, "");
	selectedSeq = selectedSeq.replace(/[@#\$%\^\&\*\({}_\+\/=:;<~`|\.,\'\"\)\?!>\]-]/g, "");
	selectedSeq = selectedSeq.replace(/[0-9]/g, "");
	selectedSeq = selectedSeq.toLowerCase();
	if ((selectedSeq.indexOf("b")!=-1)||(selectedSeq.indexOf("j")!=-1)||(selectedSeq.indexOf("o")!=-1)||(selectedSeq.indexOf("u")!=-1)||
	(selectedSeq.indexOf("z")!=-1)||(selectedSeq.indexOf("x")!=-1)){ 
		selectedSeq="Contains Illegal chars";
		return selectedSeq;
	} else {
		selectedSeq = selectedSeq.toUpperCase();
		//selectedSeq = selectedSeq+"*";
      	return selectedSeq;
	}
}

function filterSeq() {
   	var selectedSeq = window.getSelection();
	if (selectedSeq.length < 1)
      	return;
	if (!(selectedSeq.indexOf("*")!=-1))
	   	processedSeq=strip(selectedSeq);
   		openWindow("about:blank", processedSeq, 0);
}

function translateSeq(frameNo){
	var selectedSeq = window.getSelection();
	if (selectedSeq.length < 1)
      	return;
	var j="";
	var translatedSeq="";
	selectedSeq=strip(selectedSeq);
	if (frameNo>2){
		selectedSeq=rev(comp(selectedSeq));
		frameNo=-(3-frameNo);
		}
	for (var i=frameNo; i<(selectedSeq.length-2); i=i+3){
		codon = selectedSeq.substring(i,(i+3));
		codon = dnatoProt(codon);
		translatedSeq=translatedSeq+codon;
	}
	openWindow("about:blank", translatedSeq, 0); 
}

function dnatoProt(triplet){
	if (triplet.search(/gc[agtcn]/gi)!=-1)
		triplet="A";
	if (triplet.search(/tg[ct]/gi)!=-1)
		triplet="C";
	if (triplet.search(/ga[tc]/gi)!=-1)
		triplet="D";
	if (triplet.search(/ga[ag]/gi)!=-1)
		triplet="E";
	if (triplet.search(/tt[tc]/gi)!=-1)
		triplet="F";
	if (triplet.search(/gg[agctn]/gi)!=-1)
		triplet="G";
	if (triplet.search(/ca[tc]/gi)!=-1)
		triplet="H";
	if (triplet.search(/at[atc]/gi)!=-1)
		triplet="I";
	if (triplet.search(/aa[ag]/gi)!=-1)
		triplet="K";
	if (triplet.search(/ct[agtcn]|tt[ag]/gi)!=-1)
		triplet="L";
	if (triplet.search(/atg/gi)!=-1)
		triplet="M";
	if (triplet.search(/aa[tc]/gi)!=-1)
		triplet="N";
	if (triplet.search(/cc[atgcn]/gi)!=-1)
		triplet="P";
	if (triplet.search(/ca[ag]/gi)!=-1)
		triplet="Q";
	if (triplet.search(/cg[agctn]|ag[ag]/gi)!=-1)
		triplet="R";
	if (triplet.search(/tc[agctn]|ag[ct]/gi)!=-1)
		triplet="S";
	if (triplet.search(/ac[agctn]/gi)!=-1)
		triplet="T";
	if (triplet.search(/gt[agctn]/gi)!=-1)
		triplet="V";
	if (triplet.search(/tgg/gi)!=-1)
		triplet="W";
	if (triplet.search(/ta[tc]/gi)!=-1)
		triplet="Y";
	if (triplet.search(/ta[ga]|tga/gi)!=-1)
		triplet="*";
	return triplet;
}

function blast(flag) {
	var selectedSeq = window.getSelection();
	var browserWindow = kWindowMediator.getMostRecentWindow("navigator:browser");
	var browser = browserWindow.getBrowser();
	if (selectedSeq.length < 1)
      	return;
	else {
	if (flag==0) 
		browser.selectedTab = browser.addTab("http://www.ncbi.nlm.nih.gov/BLAST/Blast.cgi?CMD=Web&LAYOUT=TwoWindows&AUTO_FORMAT=Semiauto&ALIGNMENTS=50&ALIGNMENT_VIEW=Pairwise&CLIENT=web&DATABASE=nr&DESCRIPTIONS=100&ENTREZ_QUERY=%28none%29&EXPECT=10&FILTER=L&FORMAT_OBJECT=Alignment&FORMAT_TYPE=HTML&NCBI_GI=on&PAGE=Nucleotides&PROGRAM=blastn&SERVICE=plain&SET_DEFAULTS.x=34&SET_DEFAULTS.y=8&SHOW_OVERVIEW=on&END_OF_HTTPGET=Yes&SHOW_LINKOUT=yes&GET_SEQUENCE=yes&QUERY="+selectedSeq);
	if (flag==1)
		browser.selectedTab = browser.addTab("http://www.ncbi.nlm.nih.gov/BLAST/Blast.cgi?CMD=Web&LAYOUT=TwoWindows&AUTO_FORMAT=Semiauto&ALIGNMENTS=50&ALIGNMENT_VIEW=Pairwise&CDD_SEARCH=on&CLIENT=web&COMPOSITION_BASED_STATISTICS=on&DATABASE=nr&DESCRIPTIONS=100&ENTREZ_QUERY=%28none%29&EXPECT=10&FILTER=L&FORMAT_OBJECT=Alignment&FORMAT_TYPE=HTML&I_THRESH=0.005&MATRIX_NAME=BLOSUM62&NCBI_GI=on&PAGE=Proteins&PROGRAM=blastp&SERVICE=plain&SET_DEFAULTS.x=41&SET_DEFAULTS.y=5&SHOW_OVERVIEW=on&END_OF_HTTPGET=Yes&SHOW_LINKOUT=yes&GET_SEQUENCE=yes&QUERY="+selectedSeq);
	if (flag==2)
		browser.selectedTab = browser.addTab("http://www.ncbi.nlm.nih.gov/BLAST/Blast.cgi?CMD=Web&LAYOUT=TwoWindows&AUTO_FORMAT=Semiauto&ALIGNMENTS=50&ALIGNMENT_VIEW=Pairwise&CLIENT=web&DATABASE=nr&DESCRIPTIONS=100&ENTREZ_QUERY=%28none%29&EXPECT=10&FILTER=L&FORMAT_OBJECT=Alignment&FORMAT_TYPE=HTML&GENETIC_CODE=0&NCBI_GI=on&PAGE=Translations&PROGRAM=tblastn&SERVICE=plain&SET_DEFAULTS.x=23&SET_DEFAULTS.y=10&SHOW_OVERVIEW=on&UNGAPPED_ALIGNMENT=no&END_OF_HTTPGET=Yes&SHOW_LINKOUT=yes&GET_SEQUENCE=yes&QUERY="+selectedSeq);
	if (flag==3) 
		browser.selectedTab = browser.addTab("http://www.ncbi.nlm.nih.gov/BLAST/Blast.cgi?CMD=Web&LAYOUT=TwoWindows&AUTO_FORMAT=Semiauto&ALIGNMENTS=250&ALIGNMENT_VIEW=Pairwise&CLIENT=web&COMPOSITION_BASED_STATISTICS=on&DATABASE=nr&CDD_SEARCH=on&DESCRIPTIONS=500&ENTREZ_QUERY=%28none%29&EXPECT=10&FORMAT_OBJECT=Alignment&FORMAT_TYPE=HTML&I_THRESH=0.005&MATRIX_NAME=BLOSUM62&NCBI_GI=on&PAGE=Proteins&PROGRAM=blastp&RUN_PSIBLAST=on&SERVICE=plain&SET_DEFAULTS.x=36&SET_DEFAULTS.y=5&SHOW_OVERVIEW=on&END_OF_HTTPGET=Yes&SHOW_LINKOUT=yes&GET_SEQUENCE=yes&QUERY="+selectedSeq);
<!--
	if (flag==4)
		browser.selectedTab = browser.addTab("http://genome.ucsc.edu/cgi-bin/hgBlat?command=start&userSeq="+selectedSeq);
	}
-->
}

function blat(){
	var selectedSeq = window.getSelection();
	var browserWindow = kWindowMediator.getMostRecentWindow("navigator:browser");
	var browser = browserWindow.getBrowser();
	browser.selectedTab = browser.addTab("http://genome.ucsc.edu/cgi-bin/hgBlat?command=start");
}

function string(flag){
	var selectedSeq = window.getSelection();
	var browserWindow = kWindowMediator.getMostRecentWindow("navigator:browser");
	var browser = browserWindow.getBrowser();
	if (selectedSeq.length < 1)
      	return;
	if (flag==0){
		browser.selectedTab = browser.addTab("http://string.embl.de/newstring_cgi/show_link_summary.pl?targetmode=proteins&sequence="+selectedSeq);
	} else {
		browser.selectedTab = browser.addTab("http://string.embl.de//newstring_cgi/show_link_summary.pl?targetmode=cogs&sequence="+selectedSeq);
	}
}

function pfam(flag){
	var selectedSeq = window.getSelection();
	var browserWindow = kWindowMediator.getMostRecentWindow("navigator:browser");
	var browser = browserWindow.getBrowser();
	if (selectedSeq.length < 1)
      	return;
	if (flag==0){
		browser.selectedTab = browser.addTab("http://www.sanger.ac.uk/cgi-bin/Pfam/blast_combo?seqtype=protein&repeatmasker=yes&database=humpub/all&type=both&out_format=html&evalue=1.0&domain_search=seg&sequence="+selectedSeq);
	} else {
		browser.selectedTab = browser.addTab("http://www.sanger.ac.uk/cgi-bin/Pfam/querypfam.pl?loc=http://www.sanger.ac.uk/cgi-bin/Pfam&db=pfam&db=prosite&terms="+selectedSeq+"&size=100");
	}
}

function prosite(){
	var selectedSeq = window.getSelection();
	selectedSeq=strip(selectedSeq);
	var browserWindow = kWindowMediator.getMostRecentWindow("navigator:browser");
	var browser = browserWindow.getBrowser();
	if (selectedSeq.length < 1)
      	return;
		browser.selectedTab = browser.addTab("http://us.expasy.org/cgi-bin/prosite/PSScan.cgi?skip=on&noprofile=1&maxhits=1000&display=nice&db=sp&seq="+selectedSeq);
}

function hydropathy(){
	var selectedSeq = window.getSelection();
	selectedSeq=strip(selectedSeq);
	var browserWindow = kWindowMediator.getMostRecentWindow("navigator:browser");
	var browser = browserWindow.getBrowser();
	if (selectedSeq.length < 1)
      	return;
		browser.selectedTab = browser.addTab("http://fasta.bioch.virginia.edu/fasta_www/cgi/pgrease.cgi?in_seq1=FASTA format&plgraph=1&win_siz=9&seq1="+selectedSeq);
}

function smart() {
	var selectedSeq = window.getSelection();
	selectedSeq=strip(selectedSeq);
	var browserWindow = kWindowMediator.getMostRecentWindow("navigator:browser");
	var browser = browserWindow.getBrowser();
	if (selectedSeq.length < 1)
      	return;
	browser.selectedTab = browser.addTab("http://smart.embl-heidelberg.de/smart/show_motifs.pl?INCLUDE_BLAST=true&DO_PFAM=true&INCLUDE_SIGNALP=true&DO_PROSPERO=true&DO_DISEMBL=true&SEQUENCE="+selectedSeq);
}


function protparam(){
	var selectedSeq = window.getSelection();
	selectedSeq=strip(selectedSeq);
	var browserWindow = kWindowMediator.getMostRecentWindow("navigator:browser");
	var browser = browserWindow.getBrowser();
	if (selectedSeq.length < 1)
      	return;
		browser.selectedTab = browser.addTab("http://us.expasy.org/cgi-bin/protparam?sequence="+selectedSeq);
}

function countcodon(){
	var selectedSeq = window.getSelection();
	selectedSeq=strip(selectedSeq);
	var browserWindow = kWindowMediator.getMostRecentWindow("navigator:browser");
	var browser = browserWindow.getBrowser();
	if (selectedSeq.length < 1)
      	return;
		browser.selectedTab = browser.addTab("http://www.kazusa.or.jp/codon/cgi-bin/countcodon.cgi?t=1&s="+selectedSeq);
}

function target(flag){
	var selectedSeq = window.getSelection();
	var browserWindow = kWindowMediator.getMostRecentWindow("navigator:browser");
	var browser = browserWindow.getBrowser();
	selectedSeq=strip(selectedSeq);
	if (selectedSeq.length < 1)
      	return;
		if (selectedSeq.charAt(0)!="M")
			selectedSeq="M"+selectedSeq;
		if (flag==0){
			browser.selectedTab = browser.addTab("http://genoplante-info.infobiogen.fr/predotar/test.seq?plastids=1&sequence="+selectedSeq);
			browser.selectedTab = browser.addTab("http://hc.ims.u-tokyo.ac.jp/iPSORT/predict.cgi?seqs="+selectedSeq+"&PROTEINTYPE=plant");
			browser.selectedTab = browser.addTab("http://psort.ims.u-tokyo.ac.jp/cgi-bin/okumura.pl?origin=animal&sequence="+selectedSeq+"&origin=plant");
		} 
		if (flag==1){
			browser.selectedTab = browser.addTab("http://genoplante-info.infobiogen.fr/predotar/test.seq?plastids=0&sequence="+selectedSeq);
			browser.selectedTab = browser.addTab("http://hc.ims.u-tokyo.ac.jp/iPSORT/predict.cgi?seqs="+selectedSeq+"&PROTEINTYPE=nonplant");
			browser.selectedTab = browser.addTab("http://psort.ims.u-tokyo.ac.jp/cgi-bin/okumura.pl?origin=animal&sequence="+selectedSeq+"&origin=animal");	
		}
}

function checkprot(selectedSeq){
	if ((selectedSeq.indexOf("b")!=-1)||(selectedSeq.indexOf("j")!=-1)||(selectedSeq.indexOf("o")!=-1)||(selectedSeq.indexOf("u")!=-1)||
	    (selectedSeq.indexOf("z")!=-1)||(selectedSeq.indexOf("x")!=-1)){ 
		return false;
	} else {
		return true;
	}
}

function checkdna(seq){
	if ((seq.indexOf("A")!=-1)||(seq.indexOf("T")!=-1)||(seq.indexOf("C")!=-1)||(seq.indexOf("G")!=-1)||(seq.indexOf("U")!=-1)){ 
		return true;
	}
}

function mol_wt(){
	var selectedSeq = window.getSelection();
	var browserWindow = kWindowMediator.getMostRecentWindow("navigator:browser");
	var browser = browserWindow.getBrowser();
	selectedSeq=strip(selectedSeq);
	if (selectedSeq.length < 1)
      	return;
	browser.selectedTab = browser.addTab('http://www.expasy.org/cgi-bin/pi_tool?protein='+selectedSeq);
}

function swiss_model(){
	var selectedSeq = window.getSelection();
	var browserWindow = kWindowMediator.getMostRecentWindow("navigator:browser");
	var browser = browserWindow.getBrowser();
	var title = "Structure_Prediction";
	if (selectedSeq.length < 1)
      	return;
	selectedSeq=strip(selectedSeq);
	if (biofoxPrefs.getCharPref('sEmail')=="") {
		selectedSeq="I am sorry but this feature requires a valid email address. Please go to <b>bioFOX options</b> and enter the details.";
		openWindow("about:blank", selectedSeq, 1);	
	} else {
		if (!(selectedSeq=="Contains Illegal chars")){
		      var tempEmail = biofoxPrefs.getCharPref('sEmail');
      		var tempFn = biofoxPrefs.getCharPref('sFirstname');
		      var tempLn = biofoxPrefs.getCharPref('sLastname');
			browser.selectedTab = browser.addTab("http://swissmodel.expasy.org//cgi-bin/sm-submit-request.cgi?FOC=F&FOC=F&FOC=P&FOC=P&blast=0.00001&results=Spdbv&NOATTACH=true&WHATCHECKreport=true&PREDICTPROTEIN=Never&FOLDREC=Never&email="+tempEmail+"&name="+tempFn+"&title="+title+"&remember=remember&sequence="+selectedSeq);
		} else {
			openWindow("about:blank", selectedSeq, 1);
		}
	}
}

function pssm(){
	var selectedSeq = window.getSelection();
	var browserWindow = kWindowMediator.getMostRecentWindow("navigator:browser");
	var browser = browserWindow.getBrowser();
	var title = "Structure_Prediction";
	if (selectedSeq.length < 1)
      	return;
	selectedSeq=strip(selectedSeq);
	//selectedSeq=selectedSeq.toUpperCase();
	if (biofoxPrefs.getCharPref('sEmail')=="") {
		selectedSeq="I am sorry but this feature requires a valid email address. Please go to <b>bioFOX options</b> and enter the details.";
		openWindow("about:blank", selectedSeq, 1);	
	} else {
		if (!(selectedSeq=="Contains Illegal chars")){
		      var tempEmail = biofoxPrefs.getCharPref('sEmail');
			browser.selectedTab = browser.addTab("http://www.sbg.bio.ic.ac.uk/~3dpssm/scripts/3dpssm_submit.cgi?usr-email="+tempEmail+"&seq-desc=Structure_Prediction&seq_format=single&global_local=yes&seg=yes&DataFormat=yes&three_iter=no&sequence="+selectedSeq);
		} else {
			openWindow("about:blank", selectedSeq, 1);
		}
	}
}

function stripSearch(){
	var selectedSeq = window.getSelection();
	if (selectedSeq.length < 1)
      	return;
	selectedSeq=strip(selectedSeq);
	selectedSeq=selectedSeq.toUpperCase();
   	var newWind=window.open("about:blank", "", "resizable=yes,width=510,height=300");
  	newWind.document.write("<html><head><title></title></head><body><table width=400 bgcolor=eeeeee><tr><td><table><tr><td><font face=courier size=2>");
	newWind.document.write(selectedSeq+"<br>");
	for (var i=1; i<=((selectedSeq.length)/25); i++){
		var str=(i-1)*25;
		str=str.toString()
		if (((i-1)*25)%25==0){
		   if (str!='0')
		     newWind.document.write(str);
			if (str.length==1){
			  for (var k=0; k<24; k++){
				newWind.document.write("&nbsp;");
			  }
			}
			if (str.length==2){
			  for (var k=0; k<23; k++){
				newWind.document.write("&nbsp;");
			  }
			}
			if (str.length==3){
			  for (var k=0; k<22; k++){
				newWind.document.write("&nbsp;");	
  			  }	
			}
			if (str.length==4){
			  for (var k=0; k<21; k++){
				newWind.document.write("&nbsp;");
			  }
			}
			if (str.length==5){
			  for (var k=0; k<20; k++){
				newWind.document.write("&nbsp;");
			  }
			}
		}
	}			
	newWind.document.write("</font></td></tr></table></td></tr></table></body></html>");
   	newWind.document.close();   
}

function complement(){
	var selectedSeq = window.getSelection();
	if (selectedSeq.length < 1)
      	return;
	selectedSeq=strip(selectedSeq);
	selectedSeq=selectedSeq.toUpperCase();
	if(checkdna(selectedSeq)==true){
		selectedSeq=comp(selectedSeq);
		openWindow("about:blank", selectedSeq, 0);
	} else {
		selectedSeq="The sequence doesnt seem to be Nucleotide";
		openWindow("about:blank", selectedSeq, 1);
	}
}

function reverse(){
	var selectedSeq = window.getSelection();
	if (selectedSeq.length < 1)
      	return;
	selectedSeq=strip(selectedSeq);
	selectedSeq=selectedSeq.toUpperCase();
	if(checkdna(selectedSeq)==true){
		selectedSeq=rev(selectedSeq);
		openWindow("about:blank", selectedSeq, 0);
	} else {
		selectedSeq="The sequence doesnt seem to be Nucleotide";
		openWindow("about:blank", selectedSeq, 1);
	}
}

function revcomp(){
	var selectedSeq = window.getSelection();
	if (selectedSeq.length < 1)
      	return;
	selectedSeq=strip(selectedSeq);
	selectedSeq=selectedSeq.toUpperCase();
	if(checkdna(selectedSeq)==true){
		selectedSeq=rev(comp(selectedSeq));
		openWindow("about:blank", selectedSeq, 0);
	} else {
		selectedSeq="The sequence doesnt seem to be Nucleotide";
		openWindow("about:blank", selectedSeq, 1);
	}
}

function comp(selectedSeq){
	var selectedSeq = window.getSelection();
	selectedSeq=strip(selectedSeq);
	selectedSeq=selectedSeq.toUpperCase();
	selectedSeq = selectedSeq.replace(/G/g,"1");
	selectedSeq = selectedSeq.replace(/C/g,"2");
	selectedSeq = selectedSeq.replace(/1/g,"C");
	selectedSeq = selectedSeq.replace(/2/g,"G");	
	selectedSeq = selectedSeq.replace(/A/g,"1");
	selectedSeq = selectedSeq.replace(/T/g,"2");
	selectedSeq = selectedSeq.replace(/1/g,"T");
	selectedSeq = selectedSeq.replace(/2/g,"A");
	selectedSeq = selectedSeq.replace(/u/g,"a");
	selectedSeq = selectedSeq.replace(/U/g,"A");
	return selectedSeq;

}

function rev(selectedSeq){
	var revseq='';
   	for (i=selectedSeq.length-1; i>=0; i--){
      	revseq+=selectedSeq.charAt(i)
	}
	return revseq;
}

function installbiobar() {
  var nsIProps = Components.classes["@mozilla.org/file/directory_service;1"].createInstance(Components.interfaces.nsIProperties);       
  var userprofile = nsIProps.get("ProfD",Components.interfaces.nsIFile);
  userprofile.append("extensions"); 
  userprofile.append("{3e559c3c-4aad-4168-bd47-e1056298df8e}");
  if (userprofile.exists()) {
    alert('Biobar is already installed on your browser');
  } else {
    InstallTrigger.startSoftwareUpdate('http://downloads.mozdev.org/biobar/biobar-1.3-ffox.xpi');
    }
}


